/******************************************************************************
* PIC USB
* interrupt.c
******************************************************************************/

/** I N C L U D E S **********************************************************/
#include <p18cxxx.h>
#include "system/typedefs.h"
#include "system/interrupt/interrupt.h"

#include "system/GlobalVariables.h"

/** V A R I A B L E S ********************************************************/
int activeRow=0;
unsigned long ArrayTest; 
int Test2;
int TestCount=0;

//far unsigned long *greenDisplay_ptr = &greenDisplay[0][0];

/** I N T E R R U P T  V E C T O R S *****************************************/

#pragma code _HIGH_INTERRUPT_VECTOR = 0x000808
void _high_ISR (void)
{
     _asm goto highISR _endasm
}
#pragma code

#pragma code _LOW_INTERRUPT_VECTOR = 0x000818
void _low_ISR (void)
{
    ;
}
#pragma code

/** D E C L A R A T I O N S **************************************************/
/******************************************************************************
 * Function:        void highISR()
 *
 * Overview:        Interrupt Service Routine for High Priority Interrupts
 *
 * Note:            None
 *****************************************************************************/
#pragma interrupt highISR
void highISR(void)
{
	if (PIR1bits.TMR2IF == 1)
    {
		PIR1bits.TMR2IF=0;
		
		if (TestCount<63)
			TestCount++;
		else if (TestCount==63){
			//LATCbits.LATC2=!LATCbits.LATC2;
			TestCount=0;
		}
		
		Test2 ++;
		if (Test2 == 1){	//1000 for debugging
			Test2=0;
		LATD=0xFF;
		ArrayTest=*greenDisplay_ptr;
		//ArrayTest= *greenDisplay_ptr;
		//ArrayTest=*(*(greenDisplay + 0) + 0);//LATD = greenDisplay [1][1];
		//ArrayTest=*(greenDisplay_ptr); // + (32 * 0));
		//printf("TEST");
		if (ArrayTest==0xFFFFFFFF){
//		if (Test==3){
			LATCbits.LATC2=0;
			LATCbits.LATC1=1;
			LATCbits.LATC0=1;
		}
		else{
			LATCbits.LATC2=1;
			LATCbits.LATC1=0;
			LATCbits.LATC0=0;
		}
		LATEbits.LATE1=1; //Clock pulse for SIPO
		LATEbits.LATE2=0;
		//RowSelect();
		//LATB= Faces[currentDisplay][activeRow];
		ADC_Conversion();
		//if (activeRow==0){
			//ADC_Averaging();
			//ADC_Output();
		//}
		activeRow ++;
		LATEbits.LATE1=0;	//Clock pulse for SIPO
		if (activeRow == MaxRow){
			activeRow=0;
			LATEbits.LATE2=1;
		}

		//activeRow ++;

		}//CLOSE TEST2

	}
} // end highISR

/******************************************************************************
 * Function:        void low_isr(void)
 * PreCondition:    None
 * Input:
 * Output:
 * Side Effects:
 * Overview:
 *****************************************************************************/
#pragma interruptlow low_isr
void low_isr(void)
{
}
#pragma code




//FUNCTINOS BLABLABLABLABLBALBALBLABLBALA
void RowSelect(void){
	if 		(activeRow == 0) LATD = 0b11111110;
	else if (activeRow == 1) LATD = 0b11111101;
	else if (activeRow == 2) LATD = 0b11111011;
	else if (activeRow == 3) LATD = 0b11110111;
	else if (activeRow == 4) LATD = 0b11101111;
	else if (activeRow == 5) LATD = 0b11011111;
	else if (activeRow == 6) LATD = 0b10111111;
	else 					 LATD = 0b01111111;
}



/** EOF interrupt.c **********************************************************/
